package org.rule;

import org.rule.parameter.*;
import org.rule.parameter.config.*;
import org.rule.util.ILogger;
import org.rule.util.LoggerFactory;
import org.rule.util.ClassUtility;

/**
 * [NXs.<br>
 * RuleConfig̏ɏ]ďs.<br>
 * ݒt@CɃ[NX̃tpX`Ȃꍇ<br>
 * setRuleClassPosition\bhgpăNX̃pbP[Wwł.<br>
 *
 * @author T.Okuyama
 */
public class RuleExecutor {

    private ILogger logger = LoggerFactory.createLogger(RuleExecutor.class);

    private String ruleClassPosition = "";

    /**
     *
     * @param obj PojołKv
     * @param ruleConfig
     *
     */
    public RuleResponse execute(Object obj, RuleConfig ruleConfig) throws Exception{
        logger.debug("execute - Jn");

        RuleResponse ruleResponse = null;
        RuleRequest ruleRequest = null;
        RuleTarget ruleTarget = null;


        try {
            ruleRequest = new RuleRequest();
            ruleTarget = new RuleTarget();

            ruleTarget.setTargetObject(obj);
            ruleTarget.setOption(null);

            ruleRequest.setRuleTarget(ruleTarget);
            ruleRequest.setRuleConfig(ruleConfig);

            // ̎sϏ
            ruleResponse = this.executeRule(ruleRequest);
        } catch (Exception e) {
            logger.fatal(e);
            throw e;
        }

        logger.debug("execute - I");
        return ruleResponse;
    }



    private RuleResponse executeRule(RuleRequest ruleRequest) throws Exception {
        logger.debug("executeRule - Jn");

        IRule rule = null; 

        RuleResponse ruleResponse = new RuleResponse();
        RuleResult ruleResult = null;

        PlainParam plainParam = null;
        RuleTarget ruleTarget = null;
        RuleConfig ruleConfig = null;
        RuleConfigMap ruleConfigMap = null;
        String[] attributeNameList = null;

        String ruleClassName = null;
        String ruleClassInitParam = null;
        String ruleClassOptionParam = null;

        try {

            ruleTarget = ruleRequest.getRuleTarget();
            ruleConfig = ruleRequest.getRuleConfig();

            // [KΏۂ̑o
            // ݒt@Cattributeɂ
            attributeNameList = ruleConfig.getTargetAttributeList();

            // [KΏە[s
            for (int attIndex = 0; attIndex < attributeNameList.length; attIndex++) {

                logger.debug("DTȎ" + attributeNameList[attIndex] + "ɑ΂ă[K");

                // [KΏۖRuleConfigMapo
                ruleConfigMap = ruleConfig.getTargetAttributeRule(attributeNameList[attIndex]);

                // [̗LmF
                if (ruleConfigMap != null) {

                    logger.debug("[L");
                    // [
                    // ^[QbgBeañp[^o
                    plainParam = new PlainParam();

                    // ɂ܂Ă邩mF
                    if (ruleConfigMap.isMultiAttribute()) {

                        // ɂ܂Ă
                        // p[^oPlainParamNXɊi[
                        plainParam.setParams(ruleTarget.getValues(ruleConfigMap.getTargetAttributeNames()));
                    } else {

                        // ɂ܂ĂȂ
                        // p[^oPlainParamNXɊi[
                        plainParam.setParam(ruleTarget.getValue(ruleConfigMap.getTargetAttributeName()));
                    }

                    // [NXs
                    while(ruleConfigMap.next()) {

                        // [NXo
                        ruleClassName = ruleConfigMap.getRuleClassName();
                        // [NX̏lo
                        ruleClassInitParam = ruleConfigMap.getRuleClassInitParam();
                        // [NXOptionlo
                        ruleClassOptionParam = ruleConfigMap.getRuleClassOptionParam();

                        logger.debug("[NX" + ruleClassName + 
                                     "l[" + ruleClassInitParam + "]Optionl[" + ruleClassOptionParam + 
                                     "]œK");

                        // [NXo
                        rule = (IRule)ClassUtility.createInstance(this.ruleClassPosition + ruleClassName);

                        // lݒ
                        rule.initRule(ruleClassInitParam, ruleClassOptionParam);

                        // [s
                        ruleResponse.addRuleResult(attributeNameList[attIndex], rule.executeRule(plainParam));
                    }
                } else {
                    // [
                    logger.debug("[");
                }
            }

        } catch (Exception e) {
            logger.fatal(e);
            throw e;
        }

        logger.debug("executeRule - I");
        return ruleResponse;
    }

    /**
     * sNX̃[gpXZbg
     * Ō"."ŏIKv
     */
    public void setRuleClassPosition(String url) {
        this.ruleClassPosition = url;
    }
}