package org.rule.parameter.config;

import java.io.InputStream;
import java.io.IOException;
import java.util.LinkedHashMap;
import java.util.Iterator;
import java.util.Properties;
import java.util.Set;

import org.rule.util.ILogger;
import org.rule.util.LoggerFactory;
import org.rule.util.ClassUtility;

/** 
 * [̐ݒǂݍݕێ
 *
 * 
 * @author T.Okuyama
 */
public class RuleConfig {

    // Logger
    private ILogger logger = LoggerFactory.createLogger(RuleConfig.class);

    // ݒt@C̃L[lQ
    private static final String ATTRIBUTE_KEY = "attribute";
    private static final String ATTRIBUTE_SEP = ",";
    private static final String MULTI_ATTRIBUTE_SEP = "&";

    private static final String JOIN_SEP = ".";

    private static final String RULE_KEY = "rule";
    private static final String RULE_SEP = ",";

    private static final String RULE_PARAM_KEY = "param";

    private static final String RULE_OPTION_KEY = "option";

    // r[̑L[ɂāÃ[LinkedHashMapƂĊi[Ă
    // i[ς݂LinkedHashMap̃L[̓[NXŁAp[^͏l
    private LinkedHashMap configMap = null;

    /**
     * ݒt@CnƂɂA
     * 
     */
    public RuleConfig(String fileName) throws Exception {
        this.configMap = new LinkedHashMap();
        this.initConfig(RuleConfig.class.getResourceAsStream(fileName));
    }

    /**
     * ݒt@Cp[X 
     *
     */
    private void initConfig(InputStream is) throws Exception {
        Properties prop = null;

        String attributes = null;
        String[] attributeList = null;
        String[] multiAttributeList = null;

        String rules = null;
        String[] ruleList = null;

        String initValue = null;
        String optionValue = null;

        RuleConfigMap ruleConfigMap = null;

        try {
            logger.debug("initConfig - Jn");
            prop = new Properties();
            prop.load(is);

            // Ώۃr[̓K[Q擾
            attributes = prop.getProperty(RuleConfig.ATTRIBUTE_KEY);

            logger.debug("ΏDTÕ[KΏۑ̑S`:[" + attributes + "]");

            // Ώۃr[̓K[Q𕪉
            attributeList = attributes.split(RuleConfig.ATTRIBUTE_SEP);

            // K[Q[𕪐
            for (int index = 0; index < attributeList.length; index++) {

                logger.debug("[KΏۑ:[" + attributeList[index] + "]");
                // K[QgpāA[o
                rules = (String)prop.remove(attributeList[index] + RuleConfig.JOIN_SEP + RuleConfig.RULE_KEY);

                // [̗L𒲂ׂ
                if (rules == null) {
                    logger.debug("[");
                    logger.debug("K[:[" + rules + "]");

                    // [Ȃ
                    // L[(r[̑)͓o^邪AlNULL
                    this.configMap.put(attributeList[index], null);
                } else {
                    logger.debug("[L");
                    logger.debug("K[:[" + rules + "]");

                    // [
                    ruleConfigMap = new RuleConfigMap();

                    // [Kɂ܂Ă邩ׂ
                    if (attributeList[index].indexOf(RuleConfig.MULTI_ATTRIBUTE_SEP) != -1) {

                        logger.debug("̑ɂ܂Ă:[" + attributeList[index] + "]");
                        // [Kɂ܂Ă
                        ruleConfigMap.setMultiAttribute(true);

                        // 𕪉Azɂ
                        multiAttributeList = attributeList[index].split(RuleConfig.MULTI_ATTRIBUTE_SEP);
                        ruleConfigMap.setTargetAttributeNames(multiAttributeList);
                    } else {

                        logger.debug("̑ɂ܂ĂȂ:[" + attributeList[index] + "]");
                        // [Kɂ܂ĂȂ
                        ruleConfigMap.setMultiAttribute(false);
                        ruleConfigMap.setTargetAttributeName(attributeList[index]);
                    }

                    // [NX̕𕪉
                    ruleList = rules.split(RuleConfig.RULE_SEP);

                    // [̐lyсAOption̒l𒲂ׂ
                    for(int index2 = 0; index2 < ruleList.length; index2++) {
                        // l擾(NULL̉\)
                        initValue = (String)prop.remove(attributeList[index] + 
                                                     RuleConfig.JOIN_SEP + 
                                                     ruleList[index2] + 
                                                     RuleConfig.JOIN_SEP + 
                                                     RuleConfig.RULE_PARAM_KEY);

                        // Optionl擾(NULL̉\)
                        optionValue = (String)prop.remove(attributeList[index] + 
                                                       RuleConfig.JOIN_SEP + 
                                                       ruleList[index2] + 
                                                       RuleConfig.JOIN_SEP + 
                                                       RuleConfig.RULE_OPTION_KEY);
                        // lۑ
                        ruleConfigMap.addRuleDetail(ruleList[index2], initValue, optionValue);

                        logger.debug("[NX" + ruleList[index2] + "̏l[" + initValue + "]");
                        logger.debug("[NX" + ruleList[index2] + "Optionl[" + optionValue + "]");
                    }

                    // L[(r[̑)lƁA[
                    this.configMap.put(attributeList[index], ruleConfigMap);
                }
            }

        } catch (Exception e) {
            logger.error("initConfig - G[");
            throw e;
        } finally {
            try {
                if (is != null) {
                    is.close();
                }
            } catch (IOException ie) {
                // 
                logger.error("initConfig - t@CXg[CLOSEɎs");
            }
        }
        logger.debug("initConfig - I");
    }

    /**
     * ݒ肳ĂconfigMap̏ɁAr[̑Xgo
     */
    public String[] getTargetAttributeList() {
        String[] returnKyes;
        int index = 0;
        String key;

        Set keys = this.configMap.keySet();   
        returnKyes = new String[keys.size()];

        for (Iterator iterator = keys.iterator(); iterator.hasNext();) {

            key = (String)iterator.next();
            returnKyes[index] = key;

            index++;
        }
        return returnKyes;
    }

    /**
     * ݒ肳ĂconfigMap̏ɁAr[̑L[ɂ̑ɕRt[o
     * [݂ȂꍇnullԂ
     */
    public RuleConfigMap getTargetAttributeRule(String attributeName) {
        RuleConfigMap ruleConfigMap = (RuleConfigMap)this.configMap.get(attributeName);

        if (ruleConfigMap != null) {
            ruleConfigMap.initNext();
        }

        return ruleConfigMap;
    }
}