package sample.rule;

import java.util.Calendar;

import org.rule.IRule;
import org.rule.parameter.RuleResult;
import org.rule.parameter.PlainParam;

/**
 * tyсÃtH[}bg`FbN
 * initValue͓nl̃tH[}bgƂ
 * optionlœtw肩Aw肩A؂蕪
 * default͓t`FbN
 * tF"DATE"
 * ԁF"TIME"
 * F"DATETIME"
 *
 */
public class CheckDateTime implements IRule {

    private String initValue = null;
    private String optionParam = null;

    /**
     * ȏ̏s
     */
    public void initRule(String initVal, String optionParam) {
        this.initValue = initVal;
        this.optionParam = optionParam;
    }


    public RuleResult executeRule(PlainParam plainParam) {
        RuleResult ruleResult = null;
        String value = null;

        try {
            value = (String)plainParam.getParam();

            if (this.optionParam == null) {
                ruleResult = this.checkDate(value);
            } else if (this.optionParam.equals("DATE")) {
                ruleResult = this.checkDate(value);
            } else if (this.optionParam.equals("TIME")) {
                ruleResult = this.checkTime(value);
            } else if (this.optionParam.equals("DATETIME")) {
                //ruleResult = this.checkDateTime(value);
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
        return ruleResult;
    }

    /**
     * t̃tH[}bg`FbNs
     */
    private RuleResult checkDate(String value) throws Exception{
        RuleResult ruleResult = new RuleResult();

        try {

            ruleResult.setName("CheckDateTime - Date");

            if (value != null) {
                if (value.equals("0")) {

                    // 
                    ruleResult.setErrorFlg(false);
                } else {

                    // 8?
                    if(!value.matches("[0-9]{8}")) {
                        // G[
                        ruleResult.setErrorFlg(true);
                        ruleResult.setErrorMessage(value +  ":ttB[h8ł͂܂");
                    } else {

                        int year  = 0;
                        int month = 0;
                        int day   = 0;
                        year  = Integer.parseInt(value.substring(0, 4));
                        month = Integer.parseInt(value.substring(4, 6));
                        day   = Integer.parseInt(value.substring(6, 8));

                        // N:1900`?
                        if(!(year >= 1900)) {

                            // G[
                            ruleResult.setErrorFlg(true);
                            ruleResult.setErrorMessage(year + ":ttB[h̔N1900NȑOł");
                        }

                        // :1`12?
                        if (!ruleResult.getErrorFlg()) {
                            if(!(month > 0 && month < 13)) {
                                // G[
                                ruleResult.setErrorFlg(true);
                                ruleResult.setErrorMessage(month + ":ttB[ȟ1`12ȊO̒lł");
                            }
                        }

                        // :ɑΉ?
                        if (!ruleResult.getErrorFlg()) {
                            Calendar cal = Calendar.getInstance();
                            cal.set(year, month-1, 1);
                            // 肤ő(ŏI)
                            int dayOfMonth = cal.getActualMaximum(Calendar.DATE);
                            
                            // ͈͓̌̔?
                            if(day > dayOfMonth || day <= 0) {
                                // G[
                                ruleResult.setErrorFlg(true);
                                ruleResult.setErrorMessage(month + "/" + day + ":Ɠ̊֌WԈႦĂ܂B");
                            }
                        }
                    }

                }
            }
        } catch (Exception e) {
            throw e;
        }
        return ruleResult;
    }


    /**
     * Ԃ̃tH[}bg`FbNs
     */
    private RuleResult checkTime(String value) throws Exception {
        RuleResult ruleResult = new RuleResult();

        try {

            ruleResult.setName("CheckDateTime - Time");

            if (value != null) {
                if (value.equals("0")) {

                    // 
                    ruleResult.setErrorFlg(false);
                } else {

                    // 擪0
                    String str = value;
                    StringBuffer sbuf = new StringBuffer();
                    for (int i = str.length() ; i < 4 ; i++) {
                        sbuf.append("0");
                    }
                    value = sbuf.append(str).toString();

                    // 4?
                    if(!value.matches("[0-9]{4}")) {
                        // G[
                        ruleResult.setErrorFlg(true);
                        ruleResult.setErrorMessage(value +  ":ԃtB[h4ł͂܂");
                    } else {

                        int hh  = 0;
                        int mi = 0;

                        hh = Integer.parseInt(value.substring(0, 2));
                        mi = Integer.parseInt(value.substring(2, 4));

                        // :0`23?
                        if (!ruleResult.getErrorFlg()) {
                            if(!(hh > -1 && hh < 24)) {
                                // G[
                                ruleResult.setErrorFlg(true);
                                ruleResult.setErrorMessage(hh + ":ԃtB[h̎0`23ȊO̒lł");
                            }
                        }

                        // :0`59?
                        if (!ruleResult.getErrorFlg()) {
                            if(!(mi > -1 && mi < 60)) {
                                // G[
                                ruleResult.setErrorFlg(true);
                                ruleResult.setErrorMessage(mi + ":ԃtB[h̕0`59ȊO̒lł");
                            }
                        }

                    }

                }
            }
        } catch (Exception e) {
            throw e;
        }
        return ruleResult;
    }
}